# ----- code 1 -----

puts 'バックスラッシュ記法（\n）と式展開（#{1 + 1}）は使えない'
puts 'エスケープすることでシングルクォーテーション（\'）を含められる'

# ----- code 2 -----

puts "バックスラッシュ記法（\n）と式展開（#{1 + 1}）が利用できる"
puts "エスケープすることでダブルクォーテーション（\"）を含められる"

# ----- code 3 -----

puts %Q[バックスラッシュ記法（\t）と式展開（#{3 * 5}）が利用できる]
puts %q(バックスラッシュ記法（\t）と式展開（#{3 * 5}）は利用できない)
puts %|パーセント記法の区切り文字には任意の記号を使える|
puts %[括弧の対応が取れていれば、区切り文字と同じ括弧（[]）をエスケープせずに使える]
