# ----- code 1 -----

object = nil
# objectがnilでないときにupcaseメソッドが実行される
unless object.nil?
  p object.upcase
end

# ----- code 2 -----

obj1 = nil
obj2 = 'not nil'

# upcaseメソッドは実行されずnilを返す
p obj1&.upcase
# upcaseメソッドが実行される
p obj2&.upcase

# ----- code 3 -----

# reverseメソッドでNoMethodErrorが発生
begin
  p nil&.upcase.reverse
rescue => e
  p e
end
#
# reverseメソッドでも&.演算子が働き、nilを返す
p nil&.upcase&.reverse
