# ----- code 1 -----

array = [1, 4, 3, 8, 7, 6, 7]
p array.sort
p array

array.sort!
p array

# ----- code 2 -----

array = [1, 4, 3, 8, 7, 6, 7]
p array.sort{|a, b| b <=> a}

# ----- code 3 -----

array = ['インコ', 'ゾウ', 'アシナガバチ']
# String#<=> 文字列を文字コード順で比較するので、
# 文字列だけの配列に対してsortを引数なしで実行すると、自動的に文字コード順に整列される
p array.sort
# 文字数の少ない順に並べ替える
p array.sort{|a, b| a.length <=> b.length}
# 文字数の多い順に並べ替える
p array.sort{|a, b| b.length <=> a.length}

# ----- code 4 -----

array = ['インコ', 'ゾウ', 'アシナガバチ']
# 以下は、array.sort{|a, b| a.length <=> b.length} と同じ
p array.sort_by{|elem| elem.length}

# ----- code 5 -----

array = ['インコ', 'ゾウ', 'アシナガバチ']
p array.sort_by{|elem| elem.length}.reverse
