# メールアドレスのパターンだけを含む文字列にマッチする
email = 'test@example.com'
matched = email.match(/\A.+@example.com\z/)
puts matched[0]

# メールアドレスのパターン以外も含む、複数行からなる文字列にはマッチしない
# ^, $を使うと意図せずマッチしてしまう
email = <<~EMAIL
  test@example.com
  怪しい文字列
EMAIL
not_matched = email.match(/\A.+@example.com\z/)
p not_matched
unintentionally_matched = email.match(/^.+@example.com$/)
puts unintentionally_matched[0]
