# ----- code 1 -----

hiragana = /\A[ぁ-ん]+\z/
katakana = /\A[ァ-ヺー]+\z/

p 'トーキョー'.match?(katakana)
p 'しんじゅく'.match?(hiragana)
p 'いちがやサナイチョウ'.match?(hiragana)

# ----- code 2 -----

hiragana = /\p{Hiragana}+/
p hiragana.match('あいうえおカキクケコ')[0]

katakana = /\p{Katakana}+/
p katakana.match('あいうえおカキクケコ')[0]
