# ----- code 1 -----

s = '1 one eins'
m = s.match(/(\d+)\s(\w+)\s(\w+)/)
puts m[0]
puts m[1]
puts m[2]
puts m[3]

# ----- code 2 -----

s = '1 one eins, 2 two zwei, 3 three drei'
puts s.gsub(/(\d+)\s(\w+)\s(\w+)/, '\3 \2 \1')

# ----- code 3 -----

s = '1 one eins'
m = s.match(/(?<numeral>\d+)\s(?<english>\w+)\s(?<german>\w+)/)
puts m[:numeral]
puts m[:english]
puts m[:german]

# ----- code 4 -----

s = '1 one eins, 2 two zwei, 3 three drei'
puts s.gsub(/(?<numeral>\d+)\s(?<english>\w+)\s(?<german>\w+)/,
            '\k<german> \k<english> \k<numeral>')
