# ----- code 1 -----

class Foo
  def self.foo
    puts 'fooの呼び出し'
  end
  private_class_method :foo

  def self.bar
    foo
  end
end

Foo.bar

begin
  Foo.foo
rescue => e
  p e
end

# ----- code 2 -----

class Foo
  class << self
    def bar
      foo
    end

    private

    def foo
      puts 'fooの呼び出し'
    end
  end
end

Foo.bar

begin
  Foo.foo
rescue => e
  p e
end
