# ----- code 1 -----

class Payment
  def initialize(amount:)
    @amount = amount
  end
end

payment1 = Payment.new(amount: 500)
payment2 = Payment.new(amount: 1000)

def payment1.total_amount
  @amount + 500
end

p payment1.total_amount

begin
  p payment2.total_amount
rescue => e
  p e
end

# ----- code 2 -----

class Payment
  def initialize(amount:)
    @amount = amount
  end

  def total_amount
    @amount + 500
  end
end

payment1 = Payment.new(amount: 500)
payment2 = Payment.new(amount: 500)

class << payment1
  def total_amount
    @amount + 300
  end
end

p payment1.total_amount
p payment2.total_amount
