# ----- code 1 -----

class Payment
  attr_reader :amount

  def initialize(amount:)
    @amount = amount
  end
end

payment = Payment.new(amount: 500)
p payment.amount

# ----- code 2 -----

class Payment
  attr_writer :amount

  def initialize(amount:)
    @amount = amount
  end

  def total_amount
    @amount + 500
  end
end

payment = Payment.new(amount: 500)
p payment.total_amount
payment.amount = 1000
p payment.total_amount

# ----- code 3 -----

class Payment
  attr_accessor :amount

  def initialize(amount:)
    @amount = amount
  end
end

payment = Payment.new(amount: 500)
p payment.amount
payment.amount = 1000
p payment.amount

# ----- code 4 -----

class Payment
  def initialize(amount:)
    @amount = amount
  end

  # ゲッターメソッドを定義する
  def amount
    @amount
  end

  # セッターメソッドを定義する
  def amount=(amount)
    @amount = amount
  end
end

payment = Payment.new(amount: 500)
p payment.amount
payment.amount = 1000
p payment.amount
