require 'date'

# wdayメソッドを用いて判定する
# 判定したい曜日が日曜日であることが直感的にわかりにくい
if Date.new(2004, 7, 25).wday == 0
  puts '2004年7月25日は日曜日です'
end

# wednesday?メソッドを用いて判定する
# 判定したい曜日が水曜日であることがすぐにわかる
if Date.new(2005, 12, 14).wednesday?
  puts '2005年12月14日は水曜日です'
end

# Timeクラスでも利用できる
p Time.new(2004, 7, 25, 4, 43, 00).sunday?
p Time.new(2004, 7, 25, 4, 43, 00).friday?
