require 'spec_helper'
require 'counter'

RSpec.describe Counter do
  after { Counter.reset }

  describe '.increment' do
    context '1回実行したとき' do
      before do
        Counter.increment
      end

      it 'カウントは1になる' do
        expect(Counter.count).to eq(1)
      end
    end

    context '2回実行したとき' do
      before do
        Counter.increment
        Counter.increment
      end

      it 'カウントは2になる' do
        expect(Counter.count).to eq(2)
      end
    end
  end
end
