# GitHubのAPIについてはhttps://docs.github.com/ja/restを参照
require 'uri'
require 'net/http'
require 'json'

class GithubStars
  def initialize(repo)
    @repo_url = URI.parse("https://api.github.com/repos/#{repo}")
  end

  def stars
    response = Net::HTTP.get(@repo_url)
    json = JSON.parse(response)
    json['stargazers_count']
  end
end
