# ----- code 1 -----

require 'csv'

users_csv = <<~CSV
  last_name,first_name,nick_name
  Kawai,Yuta,budo
  Yamamoto,Kohei,kymmt
  Shimoju,Hiroshi,shimoju
CSV

# CSV文字列を読み込む
csv_from_string = CSV.parse(users_csv)
p csv_from_string

File.write('users.csv', users_csv)
# CSVファイルから読み込む
csv_from_file = CSV.read('users.csv')
p csv_from_file

# ----- code 2 -----

require 'csv'

users_csv = <<~CSV
  last_name,first_name,nick_name
  Kawai,Yuta,budo
  Yamamoto,Kohei,kymmt
  Shimoju,Hiroshi,shimoju
CSV

# CSV文字列を読み込む
csv_from_string = CSV.parse(users_csv, headers: true)
p csv_from_string # 配列ではないことが確認できる
p csv_from_string.headers

# ----- code 3 -----

require 'csv'

users_csv = <<~CSV
  last_name,first_name,nick_name
  Kawai,Yuta,budo
  Yamamoto,Kohei,kymmt
  Shimoju,Hiroshi,shimoju
CSV

File.write('users.csv', users_csv)
CSV.foreach('users.csv') { |row| p row }
