# ----- code 1 -----

require 'mysql2'

client = Mysql2::Client.new(host: 'localhost', username: 'root', password: 'passw0rd', database: 'test')
client.query('SELECT * FROM users').each do |row|
  p row
end

# ----- code 2 -----

require 'mysql2'

client = Mysql2::Client.new(username: 'root', password: 'passw0rd', database: 'test')
client.query("SELECT * FROM users").each(as: :array) do |row|
  p row
end

# ----- code 3 -----

require 'mysql2'

client = Mysql2::Client.new(username: 'root', password: 'passw0rd', database: 'test')
stmt = client.prepare("SELECT * FROM users WHERE id IN (?, ?)")
stmt.execute(1, 3).each do |row|
  p row
end
