# ----- code 1 -----

require 'active_record'
require 'sqlite3'

ActiveRecord::Base.establish_connection(adapter: 'sqlite3', database: 'test.db')

class User < ActiveRecord::Base
end

# ----- code 2 -----

require 'active_record'
require 'sqlite3'

ActiveRecord::Base.establish_connection(adapter: 'sqlite3', database: 'test.db')

class User < ActiveRecord::Base
end

SEPARATOR = '---'.freeze

puts "aliceのemailを取得"
alice = User.find(1)
puts alice.email

puts SEPARATOR

puts "bobのレコードを取得"
bob = User.where(email: 'bob@example.com')[0]
p bob

puts SEPARATOR

puts "daveのレコードを作成"
dave = User.create(email: 'dave@example.com')
p dave

puts SEPARATOR

puts "daveのemailを更新"
dave.update(email: 'dave@new.example.com')
p dave

puts SEPARATOR

puts "総ユーザ数: #{User.count}"
puts "daveの削除"
dave.destroy
puts "総ユーザ数: #{User.count}"
