# ----- code 1 -----

# カンマで区切って多重代入する
a, b = 1, 2
puts "a: #{a}, b: #{b}"

# 配列を使って多重代入する
c, d = [3, 4]
puts "c: #{c}, d: #{d}"

# ----- code 2 -----

# 最後の要素である4は無視される
a, b = 2, 3, 4
puts "a: #{a}, b: #{b}"

# 変数eにはnilが代入される
c, d, e = [5, 6]
puts "c: #{c}, d: #{d}"
p e

# ----- code 3 -----

a, b, *c = [1, 2, 3, 4, 5]
puts "a: #{a}, b: #{b}, c: #{c}"

# ----- code 4 -----

a, b = 1, 5
a, b = b, a
puts "a: #{a}, b: #{b}"
