# ----- code 1 -----

Rectangle = Struct.new(:width, :height)
rectangle = Rectangle.new(10, 20)

puts "width: #{rectangle.width}, height: #{rectangle.height}"
rectangle.height = 30
puts "width: #{rectangle.width}, height: #{rectangle.height}"

# ----- code 2 -----

# Ruby 3.2以降
Rectangle = Struct.new(:width, :height)
rectangle = Rectangle.new(height: 30, width: 20)

puts "width: #{rectangle.width}, height: #{rectangle.height}"

# ----- code 3 -----

# Ruby 3.1まで
Rectangle = Struct.new(:width, :height, keyword_init: true)
rectangle = Rectangle.new(height: 30, width: 20)

# ----- code 4 -----

Rectangle = Struct.new(:width, :height)
rectangle = Rectangle.new(10, 20)

rectangle.each do |value|
  puts value
end

rectangle.each_pair do |key, value|
  puts "#{key}: #{value}"
end

p rectangle.to_h
