# ----- code 1 -----

p 'hello'.upcase

# ----- code 2 -----

require 'digest'

# Digestモジュールに属するSHA256クラスのhexdigestクラスメソッドを呼び出す
p Digest::SHA256.hexdigest('ruby')

# クラスメソッドは::で区切って呼び出すこともできる
p Digest::SHA256::hexdigest('ruby')

# SHA256クラスではなくSHA256メソッドを呼び出そうとするため、NoMethodErrorが発生
begin
  p Digest.SHA256.hexdigest('ruby')
rescue => e
  p e
end
