# ----- code 1 -----

array = [nil, 1, nil, nil, 2, 3, nil, 4, nil, 5, nil, nil]
p array.compact
p array
array.compact!
p array

# ----- code 2 -----

class User
  attr_reader :age
  def initialize(age: nil)
    @age = age
  end
end

# 年齢不明のデータが含まれる配列
users = [User.new(age: 63), User.new(age: 32), User.new,
         User.new(age: 47), User.new]
p users.map(&:age)

user_ages = users.map(&:age).compact
p user_ages
