# ----- code 1 -----

class Foo
  # クラス読み込み時にクラスインスタンス変数を設定する
  @foo = 'デフォルトのクラスインスタンス変数'

  def self.settings
    { foo: @foo }
  end

  # メソッド呼び出し時にクラスインスタンス変数を更新する
  def self.update_settings
    @foo = '更新されたクラスインスタンス変数'
  end
end

class Bar < Foo
end

# Fooの中で@fooを取得、更新できる
puts Foo.settings
Foo.update_settings
puts Foo.settings

# Barからは@fooにアクセスできない
puts Bar.settings
