# ----- code 1 -----

class Payment
  def self.total_amount(amount)
    amount + 500
  end
end

p Payment.total_amount(500)
p Payment::total_amount(1000)

# ----- code 2 -----

class Payment
  class << self
    def total_amount(amount)
      amount + 500
    end
  end
end

p Payment.total_amount(500)

# ----- code 3 -----

class Payment
  def Payment.total_amount(amount)
    amount + 500
  end
end

p Payment.total_amount(500)
