class Payment # 決済方法
  def initialize(amount:)
    @amount = amount
  end

  def total_amount
    @amount + fee
  end

  def fee
    0
  end
end

class CreditCard < Payment # クレジットカード
  def fee
    super
  end
end

class CashOnDelivery < Payment # 代金引換
  def fee
    500
  end
end

p CreditCard.new(amount: 1000).total_amount
p CashOnDelivery.new(amount: 1000).total_amount
