# ----- code 1 -----

require 'timecop'

time = Time.new(2022, 1, 1, 0, 0, 0)
Timecop.freeze(time)

3.times do
  puts Time.now
  sleep 1
end

# ----- code 2 -----

require 'timecop'

time = Time.new(2022, 1, 1, 0, 0, 0)
Timecop.travel(time)

3.times do
  puts Time.now
  sleep 1
end

# ----- code 3 -----

require 'timecop'

time = Time.new(2022, 1, 1, 0, 0, 0)
Timecop.travel(time)
Timecop.scale(60)

3.times do
  puts Time.now
  sleep 1
end

# ----- code 4 -----

require 'timecop'

Timecop.freeze(Time.new(2022, 1, 1, 0, 0, 0))
puts Time.now

# ここで変更された時刻が元に戻る
Timecop.return
puts Time.now

# ブロック内でのみ時刻が変更されるため、Timecop.returnメソッドを呼び出す必要がない
Timecop.freeze(Time.new(2023, 1, 1, 0, 0, 0)) do
  puts Time.now
end

puts Time.now
