# ----- code 1 -----

begin
  1 / 0 # ZeroDivisionError例外が発生
rescue ZeroDivisionError => e
  p e
end

# ----- code 2 -----

begin
  p undefined # NameError例外が発生
rescue ZeroDivisionError, NameError => e
  p e
end

# ----- code 3 -----

begin
  array = [1, 2]
  array.fetch(3) # IndexError例外が発生
rescue => e
  p e
end

# ----- code 4 -----

def division(left, right)
  left / right
rescue
  "除算できません"
end

puts '===10/2の結果==='
puts division(10, 2)
puts '===10/0の結果==='
puts division(10, 0)

2.downto(0) do |num|
  puts "===10/#{num}の結果==="
  puts 10 / num
  rescue
    puts "除算できません"
end
