# 同じディレクトリにあるbook.rbを読み込む
require_relative 'book'

RSpec.describe Book do
  describe '.new' do
    context 'ISBNが13桁ではないとき' do
      it 'ArgumentErrorが発生する' do
        expect { Book.new(title: 'Pythonコードレシピ集', isbn: '978-4-297-11861-') }.to raise_error(ArgumentError)
      end
    end

    context 'ISBNが13桁のとき' do
      it '例外は発生しない' do
        expect { Book.new(title: 'Pythonコードレシピ集', isbn: '978-4-297-11861-7') }.not_to raise_error
      end
    end
  end
end
