# ----- code 1 -----

require 'minitar'
require 'zlib'

Zlib::GzipWriter.open('output.tar.gz') do |gz|
  Minitar.pack('input_dir', gz)
end

# ----- code 2 -----

require 'minitar'
require 'zlib'

input_filenames = %w(foo.txt bar.txt baz.txt)
Zlib::GzipWriter.open('output.tar.gz') do |gz|
  Minitar.open(gz, 'w') do |output_tar|
    input_filenames.each do |input_filename|
      Minitar.pack_file(input_filename, output_tar)
    end
  end
end
