require 'net/http'
require 'rss'

response = Net::HTTP.get(URI.parse('https://www.ruby-lang.org/ja/feeds/news.rss'))
feed = RSS::Parser.parse(response)
# RSSのタイトルを取得する
puts feed.channel.title
# 各記事のタイトルを出力する
feed.channel.items.each do |item|
  puts item.title
end
