class SampleApp
  def call(env)
    request = Rack::Request.new(env)
    text =
      if request.path == '/ja'
        'おはよう、Rack!!'
      else
        'Hello, Rack!!'
      end

    response = Rack::Response.new(
      text, 200, { 'content-type' => 'text/plain' }
    )
    # メソッド呼び出しの形でCache-Controlを設定する
    response.cache_control = 'max-age=300'
    # 任意のヘッダーを追加する
    response.add_header 'x-test-header', 'foobar'
    # レスポンスを生成する
    response.finish
  end
end
