require 'rack'
require 'digest'
require_relative 'sample_app'

use Rack::Auth::Basic do |username, password|
  username_verified = Rack::Utils.secure_compare(
    Digest::SHA256.digest('ruby'),
    Digest::SHA256.digest(username)
  )

  password_verified = Rack::Utils.secure_compare(
    Digest::SHA256.digest('rails'),
    Digest::SHA256.digest(password)
  )

  username_verified && password_verified
end

run SampleApp.new
